﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace PlayCard
{
    public partial class Form1 : Form
    {
        //将牌定义成对象
        public class Card
        { 
            public int Value=0 ;
            public override string ToString()
            {
                return Value.ToString();
            } 
        }

        //测试算法，记录了翻牌过程
        static List<string> TestResult(Card[] arr)
        {
            if (arr == null)
            { 
               throw new Exception("参数异常");
            }
            int len = arr.Length;
            Queue<Card> queue = new Queue<Card>(len);
            foreach (Card i in arr)
            {
                queue.Enqueue(i);
            }
            List<string> list = new List<string>(len);
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < len; i++)
            {
                list.Add(GetItem(sb.ToString(),queue));
                Card cur = queue.Dequeue();
                queue.Enqueue(cur);
                sb.Append(queue.Dequeue().ToString().PadRight(3,' ')+"  ");
            }
            return list;
        }

        static string GetItem(string s,Queue<Card> queue)
        { 
            StringBuilder sb = new StringBuilder(s);
            foreach (var item in queue)
            {
                sb.Append(item.ToString().PadRight(3, ' ') + "  ");
            }
            return sb.ToString();
        }

        //实现翻牌的算法
        static Card[] TestArr(int size)
        {
            Card[] arr = new Card[size];
            for (int i = 0; i < size; i++)
            {
                arr[i] = new Card();
            }
            int len = arr.Length;
            Queue<Card> queue = new Queue<Card>(len);
            foreach (Card i in arr)
            {
                queue.Enqueue(i);
            }
            for (int i = 1; i <= len; i++)
            {
                Card cur = queue.Dequeue();
                queue.Enqueue(cur);
                cur = queue.Dequeue();
                cur.Value = i;
            }
            return arr;
        }
        public Form1()
        {
            InitializeComponent();
        }

        private void btnAction_Click(object sender, EventArgs e)
        {
            int size = int.Parse(txtSize.Text);
            Card[] cardList = TestArr(size);
            StringBuilder sb = new StringBuilder(size * 3);
            foreach (var item in cardList)
            {
                sb.Append(item.ToString().PadRight(3,' ') + "  ");
            }
            txtStart.Text = sb.ToString();
            List<string> list= TestResult(cardList);
            txtEnd.Text = list[list.Count - 1];
            lbxContent.Items.Clear();
            foreach (string item in list)
            {
                lbxContent.Items.Add(item);
            }
        }

        private void txtSize_TextChanged(object sender, EventArgs e)
        {
            Regex regex = new Regex(@"^\d{1,3}$");
            if (!regex.IsMatch(txtSize.Text.Trim()))
            {
                txtSize.Text = string.Empty;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           
        }

       
        private void Form1_SizeChanged(object sender, EventArgs e)
        {
            lbxContent.Width = this.Width - 40;
            lbxContent.Height = this.Height - 200;
            txtStart.Width = txtEnd.Width = this.Width - 103;
        }
    }
}
